#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum AssetSortField {
    #[serde(rename = "NAME")]
    Name,
    #[serde(rename = "CREATED_AT")]
    CreatedAt,
    #[serde(rename = "MOST_RECENT_RUN_START")]
    MostRecentRunStart,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl AssetSortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            AssetSortField::Name => "NAME",
            AssetSortField::CreatedAt => "CREATED_AT",
            AssetSortField::MostRecentRunStart => "MOST_RECENT_RUN_START",
            AssetSortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for AssetSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for AssetSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for AssetSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<AssetSortField, conjure_object::plain::ParseEnumError> {
        match v {
            "NAME" => Ok(AssetSortField::Name),
            "CREATED_AT" => Ok(AssetSortField::CreatedAt),
            "MOST_RECENT_RUN_START" => Ok(AssetSortField::MostRecentRunStart),
            v => v.parse().map(|v| AssetSortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for AssetSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<AssetSortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the AssetSortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
